'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var React = require('react');

var _require = require('react-router-config'),
    matchRoutes = _require.matchRoutes,
    renderRoutes = _require.renderRoutes;

var _require2 = require('react-dom/server'),
    renderToString = _require2.renderToString;

var _require3 = require('react-router-dom'),
    StaticRouter = _require3.StaticRouter;

var _require4 = require('react-redux'),
    Provider = _require4.Provider;

var clientRouterCreator = require('../tool/clientRouterCreator');
var storeCreator = require('../tool/storeCreator');
var rootSaga = require('../tool/rootSagaCreator');

// webpack打包的时候会动态合成所有router文件并塞入global.__CLIENT_ROUTER__
var clientRouters = clientRouterCreator(global.__CLIENT_ROUTER__);

/**
 * 服务器端渲染中间件
 *
 * 该方法返回koa中间件，中间件作用是根据ctx.request来判断
 * 是否需要做服务器端渲染
 * TODO 待补充注释：初次发送请求逻辑
 *
 * @param    void
 * @returns  async(ctx, next)
 *
 * @date     2018-02-17
 * @author   yanzhenggang<robinyzg@hotmail.com>
 */
module.exports = function () {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(ctx, next) {
      var store, renderHtmlString, isNotRootRoute, matchedRouter, promises;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              store = storeCreator();

              store.runSaga(rootSaga());

              /**
               * ------------------------------------------------------------------
               * render a html string contains the matched route
               * ------------------------------------------------------------------
               */

              renderHtmlString = function () {
                var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                  var context;
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          /* ***************************** */
                          /*          if NECESSARY         */
                          /*    TODO: context handler      */
                          /* TODO: inititalDataArr handler */
                          /* ***************************** */

                          context = {};
                          // function render is added into ctx via PKG koa-views

                          _context.next = 3;
                          return ctx.render('index', {
                            root: renderToString(React.createElement(
                              Provider,
                              { store: store },
                              React.createElement(
                                StaticRouter,
                                {
                                  location: ctx.request.url,
                                  context: context
                                },
                                renderRoutes(clientRouters)
                              )
                            )),
                            state: store.getState()
                          });

                        case 3:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, undefined);
                }));

                return function renderHtmlString() {
                  return _ref2.apply(this, arguments);
                };
              }();

              /**
               * ------------------------------------------------------------------
               * this is a filter used for Array.prototype.filter
               * it will filter the root router('/')
               * ------------------------------------------------------------------
               */


              isNotRootRoute = function isNotRootRoute(_ref3) {
                var match = _ref3.match;
                return match.path !== '/';
              };

              // get all matched Routes & filter the one which is not the root one('/')


              matchedRouter = matchRoutes(clientRouters, ctx.request.path).filter(isNotRootRoute);

              if (!(!Array.isArray(matchedRouter) || matchedRouter.length === 0)) {
                _context2.next = 7;
                break;
              }

              return _context2.abrupt('return', next());

            case 7:
              promises = matchedRouter.map(function (_ref4) {
                var route = _ref4.route;
                return route.component.pageInit instanceof Function ? route.component.pageInit(store, rootSaga) : Promise.resolve(null);
              });

              // trigger the saga promise ends;
              // dispatch saga中名为END的action，此action的作用是停止saga对新的take的监听，只保留对当前在活动中的take的监听，这样做是为了保证服务器端和客户端的结果一致 (猜测的好像不对)

              store.close();

              // render html string after all the promise resolved.
              _context2.next = 11;
              return Promise.all(promises).then(renderHtmlString).catch(function (err) {
                /* ***************************** */
                /*      TODO: error handler      */
                /* ***************************** */
                ctx.logger.error('server render error:  ' + err);
                // print Call Stack
                console.log(err);
              });

            case 11:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};